#ifndef _HARK__BEAMFORMING__GJ_H__INCLUDED_
#define _HARK__BEAMFORMING__GJ_H__INCLUDED_ 1

#include "BF.h"

namespace BF
{
    class GJ : public BF
    {
    public:
        GJ(int numFreq, int samplingRate, double soundSpeed, bool muAdp, double mu);
	virtual ~GJ();

    public:
	virtual BfType getBfAlgorithmType() const { return BfGJ; }

	virtual void updateSources(const std::vector<SourceLocation> &sourcePositions);
	virtual void adaptSeparationMatrices();

    private:
	std::vector<Matrix> Wc; /* sizs_is(numFreq), element_is(Matrix(numSrc, numMic)) */
	std::vector<Matrix> Ws; /* sizs_is(numSrc * numFreq), element_is(Matrix(numMic-1, numMic)) */
	std::vector<Matrix> Al; /* sizs_is(numFreq), element_is(Matrix(numSrc, numMic-1)) */
	double mu;
	bool muAdp;

    };
}

#endif
