#ifndef _HARK__BEAMFORMING__GSS_H__INCLUDED_
#define _HARK__BEAMFORMING__GSS_H__INCLUDED_ 1

#include "BF.h"

namespace BF
{
    class GSS : public BF
    {
    public:
        GSS(int numFreq, int samplingRate, double soundSpeed, bool muAdp, double mu, bool mu_ssAdp, double mu_ss, double scale, NlFuncType nlFuncType);
	virtual ~GSS();

    public:
	virtual BfType getBfAlgorithmType() const { return BfGSS; }

	virtual void updateSources(const std::vector<SourceLocation> &sourcePositions);
	virtual void adaptSeparationMatrices();

    private:
	NlFuncType nlFuncType;
	double mu, mu_ss, scale;
	bool muAdp, mu_ssAdp;

    };
}

#endif
