#include "BF.h"
#include "BF_Matrix.h"

namespace BF
{
    template<typename T>
    double distance(const T&a, const T&b)
    {
	return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y) + (a.z - b.z) * (a.z - b.z));
    }

    int
    TransformFunctionDatabase::findNearestSourceIndex(const SourceLocation &sourceLocation) const
    {
	double mind = 0;
	int    mini = 0;
	for(int i = 0; i < this->sourceLocations.size(); i++){
	    const SourceLocation &s = this->sourceLocations[i];
	    double d = distance(s, sourceLocation);
	    if(i == 0 || d < mind){
		mind = d;
		mini = i;
	    }
	}

	return mini;
    }

    int
    TransformFunctionDatabase::findNearestSourceIndex(const MicLocation &micLocation) const
    {
	double mind = 0;
	int    mini = 0;
	for(int i = 0; i < this->micLocations.size(); i++){
	    const MicLocation &m = this->micLocations[i];
	    double d = distance(m, micLocation);
	    if(i == 0 || d < mind){
		mind = d;
		mini = i;
	    }
	}

	return mini;
    }
    
}
